/* ---------------------------------------------------------- */
/*  kome_audio_drv.h                                          */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		V850/DAC audio driver
    @author		rerofumi
    @since		Jul.13.2007
*/
/*-----------------------------------------------------
 Copyright (C) 2007 rerofumi <rero2@yuumu.org>
 -  Kome wo kame.
 ------------------------------------------------------*/

#ifndef KOME_AUDIO_DRV_H
#define KOME_AUDIO_DRV_H

#ifndef __SDL__
#pragma ioreg
#endif


/*-------------------------------*/
/* include                       */
/*-------------------------------*/

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/* --- o̓obt@TCY */
#ifdef __GP2X__
#define KOMEAUDIO_BUFFERSIZE   256
#else
#define KOMEAUDIO_BUFFERSIZE   2000
#endif

/* --- o̓^C}[ */
#define KOMEAUDIO_TIMER   64

/* --- `l */
#define KOMEAUDIO_CHANNEL   4

/* --- ߂l */
enum {
  AUDIO_DONE = 0,
  AUDIO_ERROR,
  AUDIO_NOT_ENABLE,
  AUDIO_WRONG_CHANNEL,
  AUDIO_IS_BUSY
};

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/* --- `l\ */
typedef struct {
  const unsigned char *data;
  int  rest;
  int  size;
  int  repeat;
} KAudioChannel, *PKAudioChannel;


/*-------------------------------*/
/* prototype                     */
/*-------------------------------*/


//! Audio hCȍ
int komeAudioInitialize(void);

//! Audio hCo̓X^[g
int komeAudioStart(void);

//! Audio hCo̓~
int komeAudioStop(void);

//! channel se request
int komeAudioSERequest(int ch, const unsigned char *ptr, int size, int repeat);

//! channel stop request
int komeAudioSEStop(int ch);



#endif
