/* ---------------------------------------------------------- */
/*  kome_display_drv.h                                        */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		V850/CPLD display driver
    @author		rerofumi
    @since		Jul.23.2007
*/
/*-----------------------------------------------------
 Copyright (C) 2007 rerofumi <rero2@yuumu.org>
 -  Kome wo kame.
 ------------------------------------------------------*/

#ifndef KOME_DISPLAY_DRV_H
#define KOME_DISPLAY_DRV_H

#ifndef __SDL__
#pragma ioreg
#endif


/*-------------------------------*/
/* include                       */
/*-------------------------------*/

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/* --- `pPbgTCY */
#define KOMEDISPLAY_PACKETSIZE   64

/* --- ߂l */
enum {
  DISPLAY_DONE = 0,
  DISPLAY_ERROR,
  DISPLAY_NOT_ENABLE,
  DISPLAY_REST_PACKET,
  DISPLAY_PACKET_FULL
};

/* --- CRTC\XCb` */
enum {
  CRTC_OFF = 0,
  CRTC_ON
};

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/* --- `pPbg\ */
typedef struct {
  unsigned char *data;
  short  pos_x, pos_y;
  short  width, height;
  unsigned char  fill_data;
} KDisplayPacket, *PKDisplayPacket;


/*-------------------------------*/
/* prototype                     */
/*-------------------------------*/


//! Display hCȍ
int komeDisplayInitialize(void);

//! Display hCoI
int komeDisplayFree(void);

//! Display packet ̃NA
int komeDisplayClearPacket(void);

//! Display packet ̃NGXg
int komeDisplayGetNumPacket(int *num);

//! CRTC ̕\XCb`
int komeDisplaySwCrtc(int sw);

//! VSync ҂\NGXg
int komeDisplayVSync(void);

//! ASynchronous \NGXg(CRTC OFFp)
int komeDisplayASync(void);


/* --- premitive work */

//! `tBNGXg
int komeDisplayFill(int x, int y, int w, int h, unsigned char fill);

//! SʃNA
int komeDisplayClearScreen(void);

//! `p^[]NGXg
int komeDisplayPattern(int x, int y, int w, int h, const unsigned char *data);


/* --- charactor display */

//! tHgp^[1\
int komeDisplayFont(int x, int y, int code);

//! tHgp^[XgO\
int komeDisplayString(int x, int y, char *str);

#endif
