/* ---------------------------------------------------------- */
/*  kv_display.h                                              */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		KomeVader game parts display
    @author		rerofumi
    @since		Aug.03.2007
*/
/*-----------------------------------------------------
 Copyright (C) 2007 rerofumi <rero2@yuumu.org>
 -  Kome wo kame.
 ------------------------------------------------------*/

#ifndef KV_DISPLAY_H
#define KV_DISPLAY_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

enum {
  DISPLAY_SHIELD_ERASE = 0,
  DISPLAY_SHIELD_NORMAL,
  DISPLAY_SHIELD_UP,
  DISPLAY_SHIELD_DOWN,
  DISPLAY_SHIELD_LEFT,
  DISPLAY_SHIELD_RIGHT,
};

enum {
  DISPLAY_MYSHIP_ERASE = 0,
  DISPLAY_MYSHIP_NORMAL,
  DISPLAY_MYSHIP_MISS_1,
  DISPLAY_MYSHIP_MISS_2,
};

enum {
  DISPLAY_SHOT_ERASE = 0,
  DISPLAY_SHOT_MYSHIP,
  DISPLAY_SHOT_ENEMY_1_1,
  DISPLAY_SHOT_ENEMY_1_2,
  DISPLAY_SHOT_ENEMY_2_1,
  DISPLAY_SHOT_ENEMY_2_2,
};

enum {
  DISPLAY_ENEMY_10_ERASE = 0,
  DISPLAY_ENEMY_10_1,
  DISPLAY_ENEMY_10_2,
  DISPLAY_ENEMY_20_ERASE,
  DISPLAY_ENEMY_20_1,
  DISPLAY_ENEMY_20_2,
  DISPLAY_ENEMY_30_ERASE,
  DISPLAY_ENEMY_30_1,
  DISPLAY_ENEMY_30_2,
  DISPLAY_ENEMY_HIT_ERASE,
  DISPLAY_ENEMY_HIT,
};

enum {
  DISPLAY_MYSTERY_ERASE = 0,
  DISPLAY_MYSTERY_1,
  DISPLAY_MYSTERY_2,
  DISPLAY_MYSTERY_HIT_ERASE,
  DISPLAY_MYSTERY_HIT,
};


/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* prototype                     */
/*-------------------------------*/

//! VSync wait \]
void kvDisplayVSync(void);


//! Q[X^[gSʏ
void kvDisplayGameStart(int hiscore, int ship);

//! XRA\NGXg
void kvDisplayScore(int x, int y, int score);

//! nCXRA\NGXg
void kvDisplayHiscore(int x, int y, int hiscore);

//! @c\NGXg
void kvDisplayMyshipRest(int rest);

//! g[`J\NGXg
void kvDisplayShield(int x, int y, int pattern);

//! @\NGXg
void kvDisplayMyship(int x, int y, int pattern);

//! e\NGXg
void kvDisplayShot(int x, int y, int pattern);

//! G\NGXg
void kvDisplayEnemy(int x, int y, int pattern);

//! ~Xe[\NGXg
void kvDisplayMystery(int x, int y, int pattern);



#endif
