/* ---------------------------------------------------------- */
/*  kv_sound.c                                                */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		KomeVader sound manage
    @author		rerofumi
    @since		Aug.03.2007
*/
/*-----------------------------------------------------
 Copyright (C) 2007 rerofumi <rero2@yuumu.org>
 -  Kome wo kame.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "kome_audio_drv.h"
#include "kv_sound.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/* -------------------------- */
/* --- TEhf[^ */

const unsigned char se_data_1[] = {
#include "wav/wav_hex/gameover.hex"
  0x80,0x80,0x80,0x80
};

const unsigned char se_data_2[] = {
#include "wav/wav_hex/inv_hit.hex"
  0x80,0x80,0x80,0x80
};

const unsigned char se_data_3[] = {
#include "wav/wav_hex/miss.hex"
  0x80,0x80,0x80,0x80
};

const unsigned char se_data_4[] = {
#include "wav/wav_hex/mystery_appear.hex"
  0x80,0x80,0x80,0x80
};

const unsigned char se_data_5[] = {
#include "wav/wav_hex/mystery_hit.hex"
  0x80,0x80,0x80,0x80
};

const unsigned char se_data_6[] = {
#include "wav/wav_hex/push_start.hex"
  0x80,0x80,0x80,0x80
};

const unsigned char se_data_7[] = {
#include "wav/wav_hex/shot.hex"
  0x80,0x80,0x80,0x80
};
const unsigned char se_data_8[] = {
#include "wav/wav_hex/start.hex"
  0x80,0x80,0x80,0x80
};

const unsigned char se_data_9[] = {
#include "wav/wav_hex/walk1.hex"
  0x80,0x80,0x80,0x80
};

const unsigned char se_data_10[] = {
#include "wav/wav_hex/walk2.hex"
  0x80,0x80,0x80,0x80
};

const unsigned char se_data_11[] = {
#include "wav/wav_hex/walk3.hex"
  0x80,0x80,0x80,0x80
};

const unsigned char se_data_12[] = {
#include "wav/wav_hex/walk4.hex"
  0x80,0x80,0x80,0x80
};


/* --------------------------------------------- */
/* --- TEhf[^ANZXe[u */

const unsigned char *se_list[12];

const int se_size[12] = {
  10071,
  472,
  4008,
  2784,
  2418,
  2690,
  842,
  17532,
  1048,
  906,
  1008,
  962
};


/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* interrupt vector              */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* --- kvSoundStart() */
/**
 * I[fBIhCȍ
 * 
 * @return Ȃ AUDIO_DONEAȊOŎs
 *
 */
int kvSoundStart(void)
{
  int  result;

  result = komeAudioInitialize();
  if (result != AUDIO_DONE) {
    return(result);
  }
  result = komeAudioStart();

  /* --- TEh|C^e[u */
  se_list[0] = se_data_1;
  se_list[1] = se_data_2;
  se_list[2] = se_data_3;
  se_list[3] = se_data_4;
  se_list[4] = se_data_5;
  se_list[5] = se_data_6;
  se_list[6] = se_data_7;
  se_list[7] = se_data_8;
  se_list[8] = se_data_9;
  se_list[9] = se_data_10;
  se_list[10] = se_data_11;
  se_list[11] = se_data_12;

  return(result);
}

/* --- kvSoundRequest() */
/**
 * TEhNGXg
 *
 * @param ch [in] `l̎w
 * @param se_num [in] SE̔ԍ
 * 
 * @return Ȃ AUDIO_DONEAȊOŎs
 *
 */
int kvSoundRequest(int ch, int se_num)
{
  int  result;

  /* --- `FbN */
  if ((ch < 0) || (ch > KOMEAUDIO_CHANNEL)) {
    return(AUDIO_WRONG_CHANNEL);
  }
  if ((se_num < 0) || (se_num > 12)) {
    return(AUDIO_ERROR);
  }

  if (se_num == 0) {
    result = komeAudioSEStop(ch);
  }
  else {
    result = komeAudioSERequest(ch, (unsigned char *)se_list[se_num-1], se_size[se_num-1]-55, 0);
  }

  return(result);
}


/* --- kvSoundStop() */
/**
 * TEh}l[W̒~
 * 
 * @return Ȃ AUDIO_DONEAȊOŎs
 *
 */
int kvSoundStop()
{
  return(komeAudioStop());
}
