/* ------------------------------------- */
/* --- include                           */
/* ------------------------------------- */

#include <stdlib.h>
#include <stdio.h>

#include "SDL.h"
#include "SDL_main.h"
#include "input.h"

#include "kome_display_drv.h"
#include "kome_audio_drv.h"
#include "kome_input_drv.h"
#include "kv_sound.h"
#include "kv_title.h"
#include "kv_game.h"

/* ------------------------------------- */
/* --- define                            */
/* ------------------------------------- */

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif


//! Xe[gx
enum {
  STATE_INITIAL = 0,
  STATE_LOGO_INIT,
  STATE_LOGO,
  STATE_TITLE_INIT,
  STATE_TITLE,
  STATE_GAME_INIT,
  STATE_GAME,
  STATE_GAMEOVER_INIT,
  STATE_GAMEOVER
};


/* ------------------------------------- */
/* --- global value                      */
/* ------------------------------------- */

/* ------------------------------------- */
/* --- mainloop (main state)             */
/* ------------------------------------- */
int  main(int argc, char *argv[])
{
  int r, score, hiscore;
  int main_state;

  /* --- fBXvC */
  if (komeDisplayInitialize() != DISPLAY_DONE) {
    exit(-1);
  }
  /* --- INPUT driver initialize */
  komeInputInitialize();
  /* --- SOUND manager initialize */
  kvSoundStart();

  main_state = STATE_INITIAL;

  /* --------------------------------- */
  /* ----- C[v */
  while(InputExit() == 0) {
    /* --- Xe[g */
    switch(main_state) {
      /* - NI[NA */
    case STATE_INITIAL:
      kvGameSetHiscore(0);
      main_state = STATE_LOGO_INIT;
      break;

      /* - T[NS */
    case STATE_LOGO_INIT:
      kvTitleSplashInitialize();
      main_state = STATE_LOGO;
      break;
      /* - T[NS\ */
    case STATE_LOGO:
      r = kvTitleSplash();
      if (TITLE_DONE == r) {
	main_state = STATE_TITLE_INIT;
      }
      break;

      /* - ^Cg */
    case STATE_TITLE_INIT:
      kvTitleInitialize();
      main_state = STATE_TITLE;
      break;
      /* - ^Cg\ */
    case STATE_TITLE:
      r = kvTitle();
      if (TITLE_DONE == r) {
	main_state = STATE_GAME_INIT;
      }
      break;

      /* - Q[ */
    case STATE_GAME_INIT:
      kvGameInitialize();
      main_state = STATE_GAME;
      break;
      /* - Q[{Ҏs */
    case STATE_GAME:
      r = kvGameTick();
      if (GAME_DONE == r) {
	main_state = STATE_GAMEOVER_INIT;
      }
      break;

      /* - ^Cg */
    case STATE_GAMEOVER_INIT:
      score = kvGameGetScore();
      hiscore = kvGameGetHiscore();
      kvTitleGameoverInitialize(score, hiscore);
      main_state = STATE_GAMEOVER;
      break;
      /* - ^Cg\ */
    case STATE_GAMEOVER:
      r = kvTitleGameover();
      if (TITLE_DONE == r) {
	main_state = STATE_LOGO_INIT;
      }
      break;

    default:
      main_state = STATE_INITIAL;
      break;
    }
  }

  /* --- I */
  kvSoundStop();
  komeInputStop();
  komeDisplayFree();

  return(0);
}
